#!/bin/bash

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

# -----------------------------------------------------------------------------------
# --- WIZARD_UIFILE / upgrade_uifile
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
# --- Set language Strings ...
# -----------------------------------------------------------------------------------
init_lang() {
/bin/cat << EOF
upTitle               = "Update AvrLogger :"
# -----------------------------------------------------------------------------------
upTitleDesc           = "<u><b>Important :</b></u> "
upTitleDesc          += "AvrLogger offers the possibility to change the fan speed via the <b>scemd.xml</b>. "
upTitleDesc          += "This function is <b>experimental</b> and the use of the function is <b>expressly</b> at your own risk!<br>"
upTitleDesc          += "<br>"
upTitleDesc          += "<u><b>Recommendation :</b></u> "
upTitleDesc          += "AvrLogger should be quit via the package center <b>before</b> changes to the network settings "
upTitleDesc          += "<b>or</b> in the Storage Manager so that they are recognized without problems.<br>"

upBoxCheckDesc        = "Okay, taken note."
upBoxCheckValidator   = "Please check : <b>Okay, taken note.</b> to continue!"

# -----------------------------------------------------------------------------------
upTitle2              = "RamDisk (Shared Memory) :"
upTitleDesc2          = "AvrLogger can use a <b>RamDisk (shared memory)</b>. This can minimize disk access and speed up "
upTitleDesc2         += "file operation.<br>"

upTitleDesc2_1        = "However, there is a risk that in the event of an unforeseen restart of the DiskStation,<br>"
upTitleDesc2_1       += "e.g. in the event of a power outage, data and settings go missing. In this case, AvrLogger "
upTitleDesc2_1       += "will try to restore the data and settings since the last start."

upBoxCheckDesc2       = "Yes, use a RamDisk (shared memory)."
upBoxCheckDesc2_1     = "Okay, taken note."
upBoxCheckValidator2  = "Please check : <b>Okay, taken note.</b> to continue!"
EOF
}

# -----------------------------------------------------------------------------------
# --- json WIZARD_UIFILE
# -----------------------------------------------------------------------------------
init_wizard() {
/bin/cat << EOF
[{
   "step_title": "${upTitle}",
   "items": [{
		"type": "multiselect",
		"desc": "${upTitleDesc}",
		"subitems": [{
		   "defaultValue": false,
			"desc":         "${upBoxCheckDesc}",
			"key":          "wizCheckNote",
			"validator":    {"fn": "{var v=arguments[0]; if (!v) return '${upBoxCheckValidator}'; return true;}"}
			         }]
		   }]
},{
   "step_title": "${upTitle2}",
   "items": [{
		"type": "multiselect",
		"desc": "${upTitleDesc2}",
		"subitems": [{
		   "defaultValue": true,
			"desc":         "${upBoxCheckDesc2}",
			"key":          "wizCheckShm"
			}]
   },{
		"type": "multiselect",
		"desc": "${upTitleDesc2_1}",
      "subitems": [{
		   "defaultValue": false,
			"desc":         "${upBoxCheckDesc2_1}",
			"key":          "wizCheckShmNote",
			"validator":    {"fn": "{var v=arguments[0]; if (!v) return '${upBoxCheckValidator2}'; return true;}"}
			        }]
		    }]
}]
EOF
}

# -----------------------------------------------------------------------------------
# --- Prepare "json WIZARD_UIFILE" ...
# -----------------------------------------------------------------------------------
var=""
while IFS= read -r line; do
    if [[ -n "${line%%\#*}" ]]; then
        value="${line#*\"}"
        if [ -z "${line/* \+\= *}" ]
            then var+="${line%% *}+=\"${value%\"*}\"\n"
            else var+="${line%% *}=\"${value%\"*}\"\n"
        fi
    fi
done <<<"$(init_lang)"
source <(echo -e $var)
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
echo -e "$(init_wizard)" > $SYNOPKG_TEMP_LOGFILE
# -----------------------------------------------------------------------------------

exit 0

# ---- END ----
