#!/bin/bash

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

# -----------------------------------------------------------------------------------
# --- WIZARD_UIFILE / upgrade_uifile
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
# --- Set language Strings ...
# -----------------------------------------------------------------------------------
init_lang() {
/bin/cat << EOF
upTitle               = "Aktualisiere AvrLogger :"
# -----------------------------------------------------------------------------------
upTitleDesc           = "<u><b>Wichtig :</b></u> "
upTitleDesc          += "AvrLogger bietet die Möglichkeit, die Lüfterdrehzahl über die <b>scemd.xml</b> zu ändern. "
upTitleDesc          += "Diese Funktion ist <b>experimentell</b> und die Nutzung der Funktion geschieht <b>ausdrücklich</b> auf eigene Verantwortung!<br>"
upTitleDesc          += "<br>"
upTitleDesc          += "<u><b>Empfehlung :</b></u> "
upTitleDesc          += "AvrLogger sollte über das Paket-Zentrum beendet werden, <b>bevor</b> Änderungen an den Netzwerkeinstellungen "
upTitleDesc          += "<b>oder</b> im Speicher-Manager vorgenommen werden, damit diese ohne Probleme erkannt werden.<br>"

upBoxCheckDesc        = "Ok, habe ich zur Kenntnis genommen."
upBoxCheckValidator   = "Bitte den Haken : <b>Ok, habe ich zur Kenntnis genommen.</b> setzen um fortzufahren!"

# -----------------------------------------------------------------------------------
upTitle2              = "RamDisk (Shared Memory) :"
upTitleDesc2          = "AvrLogger kann eine <b>RamDisk (Shared Memory)</b> verwenden. Dadurch können Festplattenzugriffe minimiert "
upTitleDesc2         += "und Dateioperation beschleunigt werden.<br>"

upTitleDesc2_1        = "Das birgt jedoch die Gefahr, das im Falle eines unvorhergesehenen Neustart der DiskStation,<br>"
upTitleDesc2_1       += "z.B. bei einem Stromausfall, Daten und Einstellungen verloren gehen. AvrLogger wird in diesem "
upTitleDesc2_1       += "Fall versuchen, die Daten und Einstellungen seit dem letztem Start wieder herzustellen."

upBoxCheckDesc2       = "Ja, eine RamDisk (Shared Memory) verwenden."
upBoxCheckDesc2_1     = "Ok, habe ich zur Kenntnis genommen."
upBoxCheckValidator2  = "Bitte den Haken : <b>Ok, habe ich zur Kenntnis genommen.</b> setzen um fortzufahren!"
EOF
}

# -----------------------------------------------------------------------------------
# --- json WIZARD_UIFILE
# -----------------------------------------------------------------------------------
init_wizard() {
/bin/cat << EOF
[{
   "step_title": "${upTitle}",
   "items": [{
		"type": "multiselect",
		"desc": "${upTitleDesc}",
		"subitems": [{
		   "defaultValue": false,
			"desc":         "${upBoxCheckDesc}",
			"key":          "wizCheckNote",
			"validator":    {"fn": "{var v=arguments[0]; if (!v) return '${upBoxCheckValidator}'; return true;}"}
			         }]
		   }]
},{
   "step_title": "${upTitle2}",
   "items": [{
		"type": "multiselect",
		"desc": "${upTitleDesc2}",
		"subitems": [{
		   "defaultValue": true,
			"desc":         "${upBoxCheckDesc2}",
			"key":          "wizCheckShm"
			}]
   },{
		"type": "multiselect",
		"desc": "${upTitleDesc2_1}",
      "subitems": [{
		   "defaultValue": false,
			"desc":         "${upBoxCheckDesc2_1}",
			"key":          "wizCheckShmNote",
			"validator":    {"fn": "{var v=arguments[0]; if (!v) return '${upBoxCheckValidator2}'; return true;}"}
			        }]
		    }]
}]
EOF
}

# -----------------------------------------------------------------------------------
# --- Prepare "json WIZARD_UIFILE" ...
# -----------------------------------------------------------------------------------
var=""
while IFS= read -r line; do
    if [[ -n "${line%%\#*}" ]]; then
        value="${line#*\"}"
        if [ -z "${line/* \+\= *}" ]
            then var+="${line%% *}+=\"${value%\"*}\"\n"
            else var+="${line%% *}=\"${value%\"*}\"\n"
        fi
    fi
done <<<"$(init_lang)"
source <(echo -e $var)
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
echo -e "$(init_wizard)" > $SYNOPKG_TEMP_LOGFILE
# -----------------------------------------------------------------------------------

exit 0

# ---- END ----
