# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'legend'

FuncDesc = { 'IconName'     : 'Legend.png',
             'SubName'      : asset.msg['modChartLegendName'],
             'SubText'      : asset.msg['modChartLegendText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange' ,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'legend+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      if case( 'legend+OnChange' ):
         break

      # -----------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "legend"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   if Out['ExpertModeOn'] == 'Yes': ExpertMode = True
   else                           : ExpertMode = False

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------
   Section( 'LegendOptions' ) 

   CheckBox ( 'LegLabelOn',    'LegLabelOn',          100, True, Row=True )

   if Out['LegLabelOn'] == "Yes":

      Select   ( 'LegLabelSize',    'LabelSize',         '60 65 70 75 80 85 90 95 100 105 110 115 120 125 130', 100, Box_1, Row=True )
      CheckBox ( 'LegColorOn',      'LegColorOn',                                                               100,        Row=True )
      Color    ( 'LegLabelColor',   'GridColor',                                                                100, Box_1, Row=True )
      CheckBox ( 'LegUndelineOn',   'LegUndelineOn',                                                            100,        Row=True )
      Select   ( 'LegUndelineSize', 'LegUndelineSize',   '0.70 0.75 0.80 0.85 0.90 0.95 1.00',                  100, Box_1, Row=True )

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------
   Section( 'LegendShape' )

   if Out['LegLabelOn'] == "Yes":
      RowOpen  ()
      SelectGUI( 'LegSign',         'LegSign',      s['LegSignGUI'], Out['LegSignRAW'], 100, Box_1 )
      RowClose()

      RowOpen  ()
      CheckBox ( 'LegIoSignOn',     'LegIoSignOn',         100 )
      RowClose()

      RowOpen  ()
      Select   ( 'LegSignSize',     'LabelSize', '60 70 80 90 100 110 120', 100, Box_1 )
      RowClose()

      RowOpen  ()
      Input   ( 'LegLabelOffset',  'LegLabelOffset',     100, 63 )
      RowClose()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------
   Section( 'LegendArrangement' )

   if Out['LegLabelOn'] == "Yes":
      RowOpen  ()
      SelectGUI( 'LegZeroX', 'LegZeroX',   s['LegZeroXGUI'], Out['LegZeroXRAW'], 100, Box_1, True )
      RowClose ()

      if Out['LegZeroX'] != 'Split':
         RowOpen ()
         SelectGUI( 'LegZeroY',     'LegZeroY',     s['LegZeroYGUI'], Out['LegZeroYRAW'], 100, Box_1 )
         RowClose()

         RowOpen ()
         Select   ( 'LegAlignment', 'LegAlignment', 'Hor Ver',   100, Box_1 )
         RowClose()

         RowOpen ()
         CheckBox( 'LegBreakOn',      'LegBreakOn',          100, True )
         RowClose()

         if Out['LegBreakOn'] != 'Yes':
            RowOpen ()
            Select ( 'LegBreakCount', 'LegBreakCount', '5 6 7 8 9 10 11 12 13 14 15', 100, Box_1 )
            RowClose()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 344 )
   # --------------------------------------------------------------------------------
   Section( 'LegendAdvanced' )

   if Out['LegLabelOn'] == "Yes":
      RowOpen ()
      Input   ( 'LegTabX',               'LegTabX',             100, 49 )
      RowClose()

      RowOpen ()
      Input   ( 'LegTabY',               'LegTabY',             100, 49 )
      RowClose()

      RowOpen ()
      Input   ( 'LegOffsetX',      'LegOffsetX',                 100, 49 )
      RowClose()

      RowOpen ()
      Input   ( 'LegOffestY',      'LegOffestY',                 100, 49 )
      RowClose()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
