# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'csv'

FuncDesc = { 'IconName'     : 'Csv.png',
             'SubName'      : asset.msg['modConfigCsvName'],
             'SubText'      : asset.msg['modConfigCsvText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange',
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'csv+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'csv+OnChange', 'csv+folder' ) :
         break

      # -----------------------------------------------------------------------------
      if case( 'csv+path' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                  # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-{FuncName}+folder', # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-{FuncName}+folder', # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelCsv'],              # Title / header
                     'FolderMode'       : 'GetFolder',                           # Function inside
                     'FolderHome'       : "",                                    # Select a "Home" folder
                     'FolderCurDir'     : asset.cgiInput['AvrLogCsvPath'],       # Start directory
                     'FolderCurFile'    : '',                                    # Preselected file
                     'FolderCurExt'     : '*',                                   # File extension (filter)
                     'FileIcon'         : '',                                    # File Icon
                     'FolderRetName'    : 'AvrLogCsvPath'                        # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         CallPage ( sDict )
         sys.exit()
         break

      # -----------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 300, 210 )
   # --------------------------------------------------------------------------------
   Section ( 'AvrLogCsv' )

   RowOpen  ()
   SelectGUI( 'AvrLogCsvMode',     'AvrLogCsvMode',     s['AvrLogCsvModeGUI'],     Out['AvrLogCsvModeRAW'],      Column_1c, 80 )
   RowClose ()

   RowOpen  ()
   CheckBox ( 'AvrLogCsvHeaderOn', 'AvrLogCsvHeaderOn',                                                           Column_1c, opt=True )
   RowClose ()

   RowOpen  ()
   SelectGUI( 'AvrLogCsvTextSign', 'AvrLogCsvTextSign', s['AvrLogCsvTextSignGUI'], Out['AvrLogCsvTextSignRAW'],  Column_1c, 140, opt=True )
   RowClose ()

   RowOpen  ()
   SelectGUI( 'AvrLogCsvDate',    'AvrLogCsvDate', s['AvrLogCsvDateGUI'], Out['AvrLogCsvDateRAW'],               Column_1c, 110, opt=True )
   RowClose ()

   RowOpen  ()
   SelectGUI( 'AvrLogCsvTime',    'AvrLogCsvTime', s['AvrLogCsvTimeGUI'], Out['AvrLogCsvTimeRAW'],               Column_1c, 110, opt=True )
   RowClose ()

   RowOpen  ()
   SelectGUI( 'AvrLogCsvColSign', 'AvrLogCsvColSign', s['AvrLogCsvColSignGUI'], Out['AvrLogCsvColSignRAW'],      Column_1c, 110, opt=True )
   RowClose ()

   RowOpen  ()
   SelectGUI( 'AvrLogCsvDecSign', 'AvrLogCsvDecSign', s['AvrLogCsvDecSignGUI'], Out['AvrLogCsvDecSignRAW'],      Column_1c, 110, opt=True )
   RowClose ()


   ContentTabEnd()

   # --------------------------------------------------------------------------------
   ContentTab ( 480, 210 )
   # --------------------------------------------------------------------------------
   iOutWidth   = iWidth  - 325
   iOutHeight  = iHeight - 432

   Section ( 'AvrLogCsvPreview' )
   divOpenBlk  ( iOutWidth, iOutHeight )

   import Csv
   print ( '\n' + Csv.Preview ( Out ) )
   divCloseBlk ()

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   ContentTab ( iWidth, 60 )
   # --------------------------------------------------------------------------------
   Section ( 'AvrLogCsvFolder' )

   RowOpen  ()
   Label    ( s['dec_AvrLogCsvPath'], 169 )
   Button   ( 'ButtonSelectCsv', '- Select -', f'{asset.PageName}-{FuncName}+path' )
   RoBox    ( 'AvrLogCsvPath', '', 0, 480, opt=not lib.FindeShare ( Out['AvrLogCsvPath'] ) )
   RowClose()

   ContentTabEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------

   # --------------------------------------------------------------------------------
   Hide( 'AvrLogCsvPath' )

   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
