# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import os

import asset
from   Html   import *

import basics as io
from   lib    import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'engine'

FuncDesc = { 'IconName'     : 'Engine.png',
             'SubName'      : asset.msg['modConfigEngineName'],
             'SubText'      : asset.msg['modConfigEngineText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more, sub=False ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'engine+init' ):
         # --------------------------------------------------------------------------
         if os.path.exists( asset.f_AvrDisabled ) : io.ioRm ( asset.f_AvrDisabled )
         else                                     : io.touch( asset.f_AvrDisabled )

         import main
         main.save()
      #  return f'{asset.PageName}-{FuncName}'
         break

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more, sub=False ) :

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, 100 )
   # --------------------------------------------------------------------------------

   Section ( 'DaemonConfirm' )

   if os.path.exists( asset.f_AvrDisabled ) : Text = s[ 'ButtonDaemonStart' ]
   else                                     : Text = s[ 'ButtonDaemonStop'  ]

   RowOpen  ()
   Label    ( 'DaemonConfirm', Column_1 )
   Button   ( 'ButtonDaemon' , Text, f'{asset.PageName}-{FuncName}+init',  iSize=80 )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
