# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
FuncName = 'list'

FuncDesc = { 'IconName'    : 'Flat.png',
             'SubName'     : asset.msg['modHddListName'],
             'SubText'     : asset.msg['modHddListText'],
             'iWidth'      : SubMenuWidth,
             'iOnChange'   : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "list"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth      = iMainOutWidth
   iHeight     = iMainHeight

   iOutWidth   = iWidth - 23
   iOutHeight  = iHeight -44

   s           = asset.msg

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight )
   # --------------------------------------------------------------------------------

   import Smart
   f    = Smart.Smart( )
   iSdl = f.scanDrives()[ 'iSdl' ]

   Section ( 'modHddList' )

   divOpenBlk ( iOutWidth, iOutHeight )
   print ( '<div id="ShareScroll" class="ScrollBar OverFlowHddList"> <!-- Start DivScroll -->' )

   print ( '+----------+-----+---------+------------------------------+--------------------+---------+------+' )
   print ( '| Location | Typ | Name    | Model                        | Serial             | Hours   |  °C  |' )
   print ( '+----------+-----+---------+------------------------------+--------------------+---------+------+' )

   # --------------------------------------------------------------------------------
   for sDev in iSdl :
      try :
         sDisk   = f.getDiskInfo( sDev )
         sAlert  = sDisk[ 'denote' ]
         apiDict = False
      except :
         lib.Error ( 'CGI: No information could be called up for the device "{0}" ... will be skipped'.format( sDev ) )
         apiDict = True
         continue

      sDisk[ 'sdl' ] = sDev
      if sDisk[ 'isSSD' ] : sDisk[ 'SSD' ] = 'SSD'
      else                : sDisk[ 'SSD' ] = 'HDD'

      # -----------------------------------------------------------------------------
      while switch( sDisk['type'] ) :
         # --------------------------------------------------------------------------
         if case( 'internal' ) :
            sDisk[ 'Locati' ] = 'NAS   {0:>2}'.format(   sDisk[ 'name' ].split( ' ')[1] )
            sAirFlow = f.getSmartAttrID( sDev, '190' )      # Airflow_Temperature_Cel
            sCelsius = f.getSmartAttrID( sDev, '194' )      # Temperature_Celsius
            sHours   = f.getSmartAttrID( sDev, '9' )
            break
         if case( 'nvme' ) :
            sDisk[ 'Locati' ] = 'M.2   {0:>2}'.format(   sDisk[ 'number' ] )
            sAirFlow = f.getSmartAttrID( sDev, 'Temperature' )
            sCelsius = False
            sHours   = f.getSmartAttrID( sDev, 'Power_on_hours' )
            break
         if case( 'ebox' ) :
            sDisk[ 'Locati' ] = 'Box-{0} {1:>2}'.format( sDisk[ 'loc' ].split( '-' )[1], sDisk[ 'name' ].split( ' ' )[1] )
            sAirFlow = f.getSmartAttrID( sDev, '190' )      # Airflow_Temperature_Cel
            sCelsius = f.getSmartAttrID( sDev, '194' )      # Temperature_Celsius
            sHours   = f.getSmartAttrID( sDev, '9' )
            break
         if case( 'usb' ) :
            sDisk[ 'Locati' ] = 'USB   {0:>2}'.format(   sDisk[ 'name' ].split( ' ')[-1] )
            sAirFlow = f.getSmartAttrID( sDev, '190' )      # Airflow_Temperature_Cel
            sCelsius = f.getSmartAttrID( sDev, '194' )      # Temperature_Celsius
            sHours   = f.getSmartAttrID( sDev, '9' )
            break
         if case( 'esata' ) :
            sDisk[ 'Locati' ] = 'eSATA {0:>2}'.format(   sDisk[ 'name' ].split( ' ')[-1] )
            sAirFlow = f.getSmartAttrID( sDev, '190' )      # Airflow_Temperature_Cel
            sCelsius = f.getSmartAttrID( sDev, '194' )      # Temperature_Celsius
            sHours   = f.getSmartAttrID( sDev, '9' )
            break
         # --------------------------------------------------------------------------
         break

   #  sAirFlow = f.getSmartAttrID( sDev, '190' )      # Airflow_Temperature_Cel
   #  sCelsius = f.getSmartAttrID( sDev, '194' )      # Temperature_Celsius

      if   not sCelsius : sCelsius = sAirFlow
      elif not sAirFlow : sAirFlow = sCelsius

      sDisk[ 'Celsius' ] = int( sAirFlow )

   #  sHours = f.getSmartAttrID( sDev, '9' )
      try    : iHours = int( sHours )
      except : iHours = int( sHours.split( 'h', 1 )[0] )

      sDisk[ 'Hours'   ] = iHours                     # Power_On_Hours

      sPage = quote( 'Hdd-view+{sdl}'.format( **sDisk ) )
      sLink = '<a class="hrefView" href="AvrConfig.cgi?page={0}" title="{1} ({sdl})" >{sdl:<7}</a>'.format( sPage, s[ 'modHddListLink' ], **sDisk )

      # -----------------------------------------------------------------------------------
      sLocati = '{Locati}'.format       ( **sDisk )
      sSSD    = '{SSD:3.3}'.format      ( **sDisk )
      sModel  = '{model:<28.28}'.format ( **sDisk )
      sSerial = '{serial:<18.18}'.format( **sDisk )

      if sAlert :
         sLocati = Colorize( sLocati, 'Red',  True )
         sSSD    = Colorize( sSSD,    'Red',  True )
         sModel  = Colorize( sModel,  'Red',  True )
         sSerial = Colorize( sSerial, 'Red',  True )

      print ( '| {1} | {2} | {0} | {3} | {4} | {Hours:>7d} | {Celsius:02d}°C |'.format( sLink, sLocati, sSSD, sModel, sSerial, **sDisk ) )

   print ( '+----------+-----+---------+------------------------------+--------------------+---------+------+' )

   # --------------------------------------------------------------------------------
   for sDev in iSdl :
      try    : sDisk = f.getDiskInfo( sDev )
      except : continue

      sAttrHistory = f.getAttrHistory( sDev )
      sAlert       = sDisk[ 'denote' ]
      iList        = sDisk['sPredict']

      # -----------------------------------------------------------------------------
      if sAttrHistory or sAlert :

         sPage = quote( 'Hdd-view+{0}'.format( sDev ) )
         sLink = '<a class="hrefView" href="AvrConfig.cgi?page={0}" title="{1} ({2})" >{2:<4}</a>'.format( sPage, s[ 'modHddListLink' ], sDev )

         print ( Colorize( '\nDisk {0} - {model} ({serial})'.format( sLink, **sDisk ), 'Gold' ) )

         for sID in [ str( x ) for x in sorted( [ int( x ) for x in iList ] ) ] :
            sPredict = sAttrHistory.get( sID, False )
            if sPredict :
               print ( '#ID {0:>3} : {1}'.format( sID, sPredict['Name'] ) )
               for sDate in sorted( sPredict['List'] ) :
                  sTimeStamp = ( Colorize( sDate + ' :', 'DodgerBlue' ) )
                  iItem = sPredict['List'][ sDate ]
                  iItem[0] = Colorize( '{0:>15}'.format( iItem[0] ), 'Lime', True )
                  iItem[1] = Colorize( '{0:<15}'.format( iItem[1] ), 'Red',  True )

                  print ( '          {0:21} {1} to {2}'.format( sTimeStamp, iItem[0], iItem[1] ) )

            if not sAlert : continue

            iItem = sAlert.get( sID, False )
            if iItem :
               if not sPredict :
                  print ( '#ID {0:>3} : {1}'.format( sID, iItem[0] ) )

               sTimeStamp = ( Colorize( 'Warning notice      :', 'Red' ) )
               iItem = sAlert[ sID ]

               iItem[1] = Colorize( '{0:>15}'.format( iItem[1] ), 'Lime', True )
               iItem[2] = Colorize( '{0:<15}'.format( iItem[2] ), 'Red',  True )

               print ( '          {0:21} {1} to {2}'.format( sTimeStamp, iItem[1], iItem[2] ) )

   if apiDict :
      apiDict = lib.getCMD( '/usr/syno/bin/synowebapi --exec api=SYNO.Storage.CGI.Storage method=load_info version=1 2>/dev/null' )
      apiDict = json.loads( apiDict )[ 'data' ]
      print ()
      print ( Colorize( '###------ synowebapi : api=SYNO.Storage.CGI.Storage ------###', 'DodgerBlue' ) )
      print ( Colorize( '>>> This dump was created due to a bug in AvrLogger', 'Gold' ) )
      print ( Colorize( '>>> Please help the author by contacting him via PM', 'Gold' ) )
      print ( Colorize( '>>> and provide this dump after clearing the serial numbers', 'Gold' ) )
      print ( Colorize( '###-------------------------------------------------------###', 'DodgerBlue' ) )
      print ( json.dumps( apiDict, sort_keys=True, indent=4 ) )

   print ( '               </div> <!-- End DivScroll -->' )
   divCloseBlk ()
   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
