# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case
import lib

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
FuncName = 'bug'

FuncDesc = { 'IconName'     : 'Bug.png',
             'SubName'      : asset.msg['modInfoBugName'],
             'SubText'      : asset.msg['modInfoBugText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange',
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'bug+rstDate' ) :

         lib.unset( asset.cgiInput, 'BugDateBox' )
         break

      # -----------------------------------------------------------------------------
      if case( 'bug+rstTime' ) :

         lib.unset( asset.cgiInput, 'BugTimeBox' )
         break

      # -----------------------------------------------------------------------------
      if case( 'bug+query' ) :

         jBusy ( 'msgCgiWaitInfo', iFlush=True )

         sDate = False
         sTime = False

         # --------------------------------------------------------------------------
         if asset.cgiInput[ 'BugDateOn' ] == 'Yes' :
            sDate = '.'.join(( asset.cgiInput[ 'BugDateYear'    ], asset.cgiInput[ 'BugDateMonth'   ],  asset.cgiInput[ 'BugDateDay'     ] ))

         # --------------------------------------------------------------------------
         if asset.cgiInput[ 'BugTimeOn' ] == 'Yes' :
            sMinute = asset.cgiInput[ 'BugTimeMinute1' ]

            if sMinute == '-' :
               sMinute += '-'
            elif asset.cgiInput[ 'BugTimeMinute2' ] != '-' :
               sMinute += asset.cgiInput[ 'BugTimeMinute2' ]

            sTime = ':'.join(( asset.cgiInput[ 'BugTimeHour' ], sMinute ))

         # --------------------------------------------------------------------------
         sKey = asset.cgiInput[ 'BugQueryString' ]
         iRet = lib.LogGrepX( sDate=sDate, sTime=sTime, sKey=sKey )

         # --------------------------------------------------------------------------

         sMeat = { 'Date' : sDate, 'Time' : sTime, 'Key' : sKey }

         if iRet : iRet = '\n'.join( iRet ) + '\n'
         else    : iRet = 'Nichts ... Nothing ... Nada ... Ничег ... Niente ... 何もない'

         import basics as io
         io.ioWrite( iRet, asset.LogSearchFile )
         io.ioWrite( json.dumps( sMeat, sort_keys=True, indent=4 ), asset.LogSearchMeta )

         """

         # --------------------------------------------------------------------------
         if iRet : iRet = printLogQuery( iRet, sDate=sDate, sTime=sTime, sKey=sKey, iMax=85 )
         else    : iRet = 'Nichts ... Nothing ... Nada ... Ничег ... Niente ... 何もない'

         import basics as io
         io.ioWrite( iRet, asset.LogSearchFile )
         """

         break
      # -----------------------------------------------------------------------------
      # -----------------------------------------------------------------------------
      if case( 'bug+OnChange' ) :

         if asset.cgiInput.get( 'BugDateBox', False ) :
            asset.cgiInput[ 'BugDateBox' ] = '.'.join(( asset.cgiInput[ 'BugDateYear'    ], asset.cgiInput[ 'BugDateMonth'   ],  asset.cgiInput[ 'BugDateDay'     ] ))

         if asset.cgiInput.get( 'BugTimeBox', False ) :
            sMinute = asset.cgiInput[ 'BugTimeMinute1' ]

            if sMinute == '-' :
               sMinute  = 'xx'
               asset.cgiInput[ 'BugTimeMinute2' ] = '-'
            elif asset.cgiInput[ 'BugTimeMinute2' ] != '-' :
               sMinute += asset.cgiInput[ 'BugTimeMinute2' ]
            else :
               sMinute += 'x'

            asset.cgiInput[ 'BugTimeBox' ] = ':'.join(( asset.cgiInput[ 'BugTimeHour' ], sMinute ))

         break

      # -----------------------------------------------------------------------------
      break


# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   # --- Prepare Values ...
   for key in asset.cgiInput :
      asset.Out[key] = asset.cgiInput[key]

# -----------------------------------------------------------------------------------
# --- Function : "bug"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   iOutWidth   = iWidth - 23
   iOutHeight  = iHeight -52

   s           = asset.msg
   Out         = asset.Out

   if Out['PopUpStickyOn'] != 'Yes' : sSticky = True
   else                             : sSticky = False

   iYear   = int( time.strftime( '%Y' ) )
   sMinute =      time.strftime( '%M' )

   # --------------------------------------------------------------------------------
   if not Out.get( 'BugDateBox', False ) :
      asset.Out[ 'BugDateOn'      ] = asset.cgiInput.get( 'BugDateOn','No' )
      asset.Out[ 'BugDateYear'    ] = str( iYear )
      asset.Out[ 'BugDateMonth'   ] = time.strftime( '%m' )
      asset.Out[ 'BugDateDay'     ] = time.strftime( '%d' )
      asset.Out[ 'BugDateBox'     ] = '.'.join(( Out[ 'BugDateYear'    ], Out[ 'BugDateMonth'   ],  Out[ 'BugDateDay'     ] ))
      asset.Out[ 'BugQueryRet'    ] = asset.cgiInput.get( 'BugQueryRet',    '' )
      asset.Out[ 'BugQueryString' ] = asset.cgiInput.get( 'BugQueryString', '' )

   if not Out.get( 'BugTimeBox', False ) :
      asset.Out[ 'BugTimeOn'      ] = asset.cgiInput.get( 'BugTimeOn','No' )
      asset.Out[ 'BugTimeHour'    ] = time.strftime( '%H' )
      asset.Out[ 'BugTimeMinute1' ] = sMinute[0]
      asset.Out[ 'BugTimeMinute2' ] = sMinute[1]
      asset.Out[ 'BugTimeBox'     ] = ':'.join(( Out[ 'BugTimeHour'    ], Out[ 'BugTimeMinute1' ] + Out[ 'BugTimeMinute2' ] ))
      asset.Out[ 'BugQueryRet'    ] = asset.cgiInput.get( 'BugQueryRet',    '' )
      asset.Out[ 'BugQueryString' ] = asset.cgiInput.get( 'BugQueryString', '' )

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, 100 )
   # --------------------------------------------------------------------------------

   Section ( 'SynoLogOption' )

   for iID in range( iYear-3, iYear+1, 1 ) :
      try    : sYear += ' ' + str( iID )
      except : sYear  =       str( iID )

   for iID in range( 1, 13, 1 ) :
      try    : sMonth += ' {:02d}'.format(iID)
      except : sMonth  =  '{:02d}'.format(iID)

   for iID in range( 1, 32, 1 ) :
      try    : sDay += ' {:02d}'.format(iID)
      except : sDay  =  '{:02d}'.format(iID)

   RowOpen ()
   CheckBox( 'BugDateOn',        'SynoLogDateSwitch',            Column_1e, opt=True )
   if Out[ 'BugDateOn' ] == 'Yes' :
      Button  ( 'ButtonResetDate',  '-Reset-', f'{asset.PageName}-{FuncName}+rstDate', iSize=60 )
      RoBox   ( 'BugDateBox',    '', 0, 85 )

      Label   ( sWhiteSpace, 20 )
      Select  ( 'BugDateDay',    'SynoLogDateDay',    sDay,   55, 45, opt=True )

      Label   ( sWhiteSpace, 20 )
      Select  ( 'BugDateMonth',  'SynoLogDateMonth',  sMonth, 60, 45, opt=True )

      Label   ( sWhiteSpace, 20 )
      Select  ( 'BugDateYear',   'SynoLogDateYear',   sYear,  40, 60, opt=True )
      Hide    ( 'BugDateBox'   )
   else :
      Hide    ( 'BugDateBox'   )
      Hide    ( 'BugDateYear'  )
      Hide    ( 'BugDateMonth' )
      Hide    ( 'BugDateDay'   )
   RowClose()

   for iID in range( 0, 24, 1 ) :
      try    : sHour += ' {:02d}'.format(iID)
      except : sHour  =  '{:02d}'.format(iID)

   sMinute1 = '- 0 1 2 3 4 5'
   sMinute2 = '- 0 1 2 3 4 5 6 7 8 9'

   RowOpen ()
   CheckBox( 'BugTimeOn',      'SynoLogTimeSwitch',                     Column_1e, opt=True )
   if Out[ 'BugTimeOn' ] == 'Yes' :
      Button  ( 'ButtonResetTime',  '-Reset-', f'{asset.PageName}-{FuncName}+rstTime', iSize=60 )
      RoBox   ( 'BugTimeBox',    '', 0, 85 )
      Hide    ( 'BugTimeBox'      )
      Label   ( sWhiteSpace, 20 )
      Select  ( 'BugTimeHour',    'SynoLogTimeHour',     sHour,          55, 45, opt=True )
      Label   ( sWhiteSpace, 20 )
      Select  ( 'BugTimeMinute1', 'SynoLogTimeMinute',   sMinute1,       60, 35, opt=True )
      Select  ( 'BugTimeMinute2', ':',                   sMinute2,        4, 35, opt=True )
   else :
      Hide    ( 'BugTimeBox'      )
      Hide    ( 'BugTimeHour'     )
      Hide    ( 'BugTimeMinute1'  )
      Hide    ( 'BugTimeMinute2'  )
   RowClose()

   RowOpen    ()
   InputOc    ( 'BugQueryString', 'SynoLogSearch',       Column_1e,  206 )
   if Out[ 'BugQueryString' ] :
      Button  ( 'ButtonQueryBug', s[ 'SynoLogSearchButton' ], f'{asset.PageName}-{FuncName}+query' )

   popButton ( 'ButtonViewJson', '- View -', 'view',  iWidth=830, iHight=485, iSize= 80, iClose=sSticky, sCgi='AvrConfig' )
   RowClose   ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --------------------------------------------------------------------------------

   ContentRow ()
   ContentTab ( iWidth, 461 )

   # --------------------------------------------------------------------------------
   Section ( 'SynoLogResults' )

   divOpenBlk ( iOutWidth, 419, sClass='BlackMonoShell' )
   print ( '<div id="ShareScroll" class="ScrollBar OverFlowHddList"> <!-- Start DivScroll -->' )

   if os.path.exists( asset.LogSearchFile ) :
      with open( asset.LogSearchFile, 'r', encoding='utf-8' ) as f :
   #     print ( f.read() )
         iRet = f.read().split( '\n' )

      with open( asset.LogSearchMeta, 'r', encoding='utf-8' ) as f :
         sMeta = json.loads( f.read() )

      print ( printLogQuery( iRet, sDate=sMeta[ 'Date' ], sTime=sMeta[ 'Time' ], sKey=sMeta[ 'Key' ], iMax=85 ) )

   print ( '</div> <!-- End DivScroll -->' )
   divCloseBlk ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
