#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# coding: utf-8                                                                      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#
import os
import sys
import glob

import re
"""
root@Tardis:~# cat /dev/bus/usb/devices

# -----------------------------------------------------------------------------------
#   --- cat :
T:  Bus=04 Lev=00 Prnt=00 Port=00 Cnt=00 Dev#=  1 Spd=5000 MxCh= 2
B:  Alloc=  0/800 us ( 0%), #Int=  0, #Iso=  0
D:  Ver= 3.00 Cls=09(hub  ) Sub=00 Prot=03 MxPS= 9 #Cfgs=  1
P:  Vendor=1d6b ProdID=0003 Rev= 3.10
S:  Manufacturer=Linux 3.10.105 etxhci_hcd-170202
S:  Product=Etron xHCI Host Controller
S:  SerialNumber=0000:0b:00.0
C:* #Ifs= 1 Cfg#= 1 Atr=e0 MxPwr=  0mA
I:* If#= 0 Alt= 0 #EPs= 1 Cls=09(hub  ) Sub=00 Prot=00 Driver=ethub
E:  Ad=81(I) Atr=03(Int.) MxPS=   4 Ivl=256ms

#   --- sh :
T:  Bus=04 Lev=00 Prnt=00 Port=00 Cnt=00 Dev#=  1 Spd=5000 MxCh= 2
D:  Ver= 3.00 Cls=09(hub  ) Sub=00 Prot=03 MxPS= 9 #Cfgs=  1
P:  Vendor=1d6b ProdID=0003 Rev=03.10
S:  Manufacturer=Linux 3.10.105 etxhci_hcd-170202
S:  Product=Etron xHCI Host Controller
S:  SerialNumber=0000:0b:00.0
C:  #Ifs= 1 Cfg#= 1 Atr=e0 MxPwr=0mA
I:  If#=0x0 Alt= 0 #EPs= 1 Cls=09(hub  ) Sub=00 Prot=00 Driver=ethub

#   --- py :
T:  Bus=04 Lev=00 Prnt=00 Port=00 Cnt=00 Dev#=  1 Spd=5000 MxCh= 2
D:  Ver= 3.00 Cls=09(hub  ) Sub=00 Prot=03 MxPS= 9 #Cfgs=  1
P:  Vendor=1d6b ProdID=0003 Rev=03.10
S:  Manufacturer=Linux 3.10.105 etxhci_hcd-170202
S:  Product=Etron xHCI Host Controller
S:  SerialNumber=0000:0b:00.0
C:  #Ifs= 1 Cfg#= 1 Atr=e0 MxPwr=0mA
I:  If#=0x00 Alt= 0 #EPs=01 Cls=09(hub  ) Sub=00 Prot=00 Driver=ethub
E:  Ad=81( in) Atr=03(Interrupt) MxPS=   4*1 Ivl=12ms
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
#   --- cat :
T:  Bus=04 Lev=01 Prnt=01 Port=00 Cnt=01 Dev#=  2 Spd=5000 MxCh= 0
D:  Ver= 3.10 Cls=00(>ifc ) Sub=00 Prot=00 MxPS= 9 #Cfgs=  1
P:  Vendor=0781 ProdID=558c Rev=10.12
S:  Manufacturer=SanDisk
S:  Product=Extreme SSD
S:  SerialNumber=313930393031343031333131
C:* #Ifs= 1 Cfg#= 1 Atr=80 MxPwr=896mA
I:* If#= 0 Alt= 0 #EPs= 2 Cls=08(stor.) Sub=06 Prot=50 Driver=usb-storage
E:  Ad=81(I) Atr=02(Bulk) MxPS=1024 Ivl=0ms
E:  Ad=02(O) Atr=02(Bulk) MxPS=1024 Ivl=0ms
I:  If#= 0 Alt= 1 #EPs= 4 Cls=08(stor.) Sub=06 Prot=62 Driver=usb-storage
E:  Ad=81(I) Atr=02(Bulk) MxPS=1024 Ivl=0ms
E:  Ad=02(O) Atr=02(Bulk) MxPS=1024 Ivl=0ms
E:  Ad=83(I) Atr=02(Bulk) MxPS=1024 Ivl=0ms
E:  Ad=04(O) Atr=02(Bulk) MxPS=1024 Ivl=0ms

#   --- sh :
T:  Bus=04 Lev=01 Prnt=01 Port=00 Cnt=01 Dev#=  2 Spd=5000 MxCh= 0
D:  Ver= 3.10 Cls=00(>ifc ) Sub=00 Prot=00 MxPS= 9 #Cfgs=  1
P:  Vendor=0781 ProdID=558c Rev=10.12
S:  Manufacturer=SanDisk
S:  Product=Extreme SSD
S:  SerialNumber=313930393031343031333131
C:  #Ifs= 1 Cfg#= 1 Atr=80 MxPwr=896mA
I:  If#=0x0 Alt= 0 #EPs= 2 Cls=08(stor.) Sub=06 Prot=50 Driver=usb-storage

#   --- py :
T:  Bus=04 Lev=01 Prnt=01 Port=00 Cnt=01 Dev#=  2 Spd=5000 MxCh= 0
D:  Ver= 3.10 Cls=00(>ifc ) Sub=00 Prot=00 MxPS= 9 #Cfgs=  1
P:  Vendor=0781 ProdID=558c Rev=10.12
S:  Manufacturer=SanDisk
S:  Product=Extreme SSD
S:  SerialNumber=313930393031343031333131
C:  #Ifs= 1 Cfg#= 1 Atr=80 MxPwr=896mA
I:  If#=0x00 Alt= 0 #EPs=02 Cls=08(stor.) Sub=06 Prot=50 Driver=usb-storage
E:  Ad=02(out) Atr=02(Bulk) MxPS=1024*1 Ivl=0ms
E:  Ad=81( in) Atr=02(Bulk) MxPS=1024*1 Ivl=0ms
B:  BlkID=24 BlkDev=sdu
# -----------------------------------------------------------------------------------
"""

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
sUsbRootPath   = '/sys/bus/usb/devices/'

busUSB   = '/sys/bus/usb/devices/'
procUSB  = '/proc/scsi/usb-storage/'

aClasses = {   '00' : '>ifc ' ,
               '01' : 'audio' ,
               '02' : 'commc' ,
               '03' : 'HID  ' ,
               '05' : 'PID  ' ,
               '06' : 'still' ,
               '07' : 'print' ,
               '08' : 'stor.' ,
               '09' : 'hub  ' ,
               '0a' : 'data ' ,
               '0b' : 'scard' ,
               '0d' : 'c-sec' ,
               '0e' : 'video' ,
               '0f' : 'perhc' ,
               'dc' : 'diagd' ,
               'e0' : 'wlcon' ,
               'ef' : 'misc ' ,
               'fe' : 'app. ' ,
               'ff' : 'vend.'
            }

usbids   = [   '@usbids@',
               '/usr/share/usb.ids',
               '/usr/share/libosinfo/usb.ids',
               '/usr/share/kcmusb/usb.ids',
               '/volume1/homes/admin/AvrLoggerSPK/usb.ids',
            #  '/usr/syno/etc/usb.map', # <<--- Die Synology 'usb.ids', jedoch hoffnungslos veraltet !!!
            ]

# -----------------------------------------------------------------------------------
# --- Short-Scan USB ID's
# -----------------------------------------------------------------------------------
def GetUsbID( opt=False ) :

   ret = dict()

   for sFile in glob.glob( procUSB + '*' ) :
      usbID = sFile.split('/')[-1]

      cat = dict()

      # -----------------------------------------------------------------------------
      for line in open( sFile, 'r', encoding='utf-8' ).readlines() :
         key, val = line.strip().split( ':' )

         cat[ key.strip() ] = val.strip()

      cat['Device Name'] = GetUsbStorage( usbID )

      ret[ usbID ] = cat

   return ret

# -----------------------------------------------------------------------------------
# --- Return SCSI block dev names for host ...
# -----------------------------------------------------------------------------------
def GetUsbStorage( sID ) :

   ret = 'NA'

   for sDev in os.listdir( '/sys/class/scsi_device/' ) :
      if not sDev.startswith( sID + ':' ) : continue

      try :
         for ret in os.listdir( '/sys/class/scsi_device/%s/device/block' % sDev ) :
            break
      except :
         pass

   # --------------------------------------------------------------------------------
   return ret

# -----------------------------------------------------------------------------------
class UsbObject :

   def read_attr( self, sName ) :
      sPath = prefix + self.path + '/' + sName
      return open( sPath ).readline().rstrip( '\n' )

      with open( sFile, 'r', encoding='utf-8' ) as f:
         return f.read().strip()

   def read_link( self, name ) :
      path = prefix + self.path + '/' + name
      return os.path.basename( os.readlink( path ) )

# -----------------------------------------------------------------------------------
# ---
# -----------------------------------------------------------------------------------
def print_endpoint( sPath ) :

   eppath = sPath

   addr        = cat( 'bEndpointAddress', eppath )
   attr        = cat( 'bmAttributes'    , eppath )
   Dir         = cat( 'direction'       , eppath )
   eptype      = cat( 'type'            , eppath )
   interval    = cat( 'interval'        , eppath )

   maxps_hex   = int( '0x' + cat( 'wMaxPacketSize', eppath ), 16 )

   # --- Extract MaxPS size (bits 0-10) and multiplicity values (bits 11-12)
   maxps       = "%4i*%i" % ( maxps_hex & 0x7ff, 1 + (( maxps_hex >> 11 ) & 0x3 ) )

   print( "E:  Ad=%s(%3s) Atr=%s(%4s) MxPS=%s Ivl=%s" % ( addr, Dir, attr, eptype, maxps, interval ) )

# -----------------------------------------------------------------------------------
# ---
# -----------------------------------------------------------------------------------
def print_interface( sPath ) :

   ifpath   = sPath

   ifnum    = cat( 'bInterfaceNumber',   ifpath )
   altset   = cat( 'bAlternateSetting',  ifpath )
   numeps   = cat( 'bNumEndpoints',      ifpath )
   Class    = cat( 'bInterfaceClass',    ifpath )
   subclass = cat( 'bInterfaceSubClass', ifpath )
   protocol = cat( 'bInterfaceProtocol', ifpath )

   if os.path.exists( ifpath + '/driver' ) :
      driver = os.path.basename( os.readlink( ifpath + '/driver' ) )
   else :
      driver = "(none)"

   classname = class_decode( Class )
   print( "I:  If#=0x%2s Alt=%2s #EPs=%2s Cls=%s(%s) Sub=%s Prot=%s Driver=%s" % ( ifnum, altset, numeps, Class, classname, subclass, protocol, driver ) )

   for endpoint in glob.glob( ifpath + '/ep_??' ) :
      print_endpoint( endpoint )

   for sHost in glob.glob( ifpath + '/host*' ) :
      iHost = sHost.split( 'host' )[-1]
      sDev  = GetUsbStorage( iHost )
      print( "B:  BlkID=%2s BlkDev=%s" % ( iHost, sDev) )

# -----------------------------------------------------------------------------------
# ---
# -----------------------------------------------------------------------------------
def print_string( sPath, sFile, sName ) :

   file = sPath + '/' + sFile
   name = sName

   if os.path.exists( file ) :
      print ( 'S:  %s=%s' % ( name, cat( sFile, sPath ) ) )

# -----------------------------------------------------------------------------------
# ---
# -----------------------------------------------------------------------------------
def cat ( sName, opt=False ) :

   if opt : sFile = opt    + '/' + sName
   else   : sFile = cdPath + '/' + sName

   with open( sFile, 'r', encoding='utf-8' ) as f:
      return f.read().strip()

# -----------------------------------------------------------------------------------
# ---
# -----------------------------------------------------------------------------------
def class_decode( sClass ) :

   if sClass in aClasses :
      return aClasses[ sClass ]
   else :
      return 'unk. '

# -----------------------------------------------------------------------------------
# ---
# -----------------------------------------------------------------------------------
def print_device( sPath, iParent, iLevel, iCount, iLF=True ) :

   devpath  = sPath
   parent   = iParent
   level    = iLevel
   count    = iCount

   if not os.path.exists( devpath ) : return False

   busnum = int( cat( 'busnum', devpath ) )
   devnum = int( cat( 'devnum', devpath ) )

   if level > 0 :
      port = int( devpath.replace( '.', '-').split( '-' )[-1] ) - 1
   else :
      port = 0

   speed    = cat( 'speed', devpath )
   maxchild = int( cat( 'maxchild', devpath ) )

   if iLF :
      print( "\nT:  Bus=%02i Lev=%02i Prnt=%02i Port=%02i Cnt=%02i Dev#=%3i Spd=%-3s MxCh=%2i" % ( busnum, level,  parent, port, count, devnum, speed, maxchild ) )
   else :
      print(   "T:  Bus=%02i Lev=%02i Prnt=%02i Port=%02i Cnt=%02i Dev#=%3i Spd=%-3s MxCh=%2i" % ( busnum, level,  parent, port, count, devnum, speed, maxchild ) )

   ver         = cat( 'version'        , devpath )
   devclass    = cat( 'bDeviceClass'   , devpath )
   devsubclass = cat( 'bDeviceSubClass', devpath )
   devprotocol = cat( 'bDeviceProtocol', devpath )
   maxps0      = int( cat( 'bMaxPacketSize0'   , devpath ) )
   numconfigs  = int( cat( 'bNumConfigurations', devpath ) )
   classname   = class_decode( devclass )

   print( "D:  Ver=%5s Cls=%s(%s) Sub=%s Prot=%s MxPS=%2i #Cfgs=%3i" % ( ver, devclass, classname, devsubclass, devprotocol, maxps0, numconfigs ) )

   vendid      = cat( 'idVendor' , devpath )
   prodid      = cat( 'idProduct', devpath )
   bcdDevice   = cat( 'bcdDevice', devpath )
   revmajor    = bcdDevice[0:2]
   revminor    = bcdDevice[2:4]

   print( "P:  Vendor=%s ProdID=%s Rev=%s.%s" % ( vendid, prodid, revmajor, revminor ) )

   print_string( devpath, 'manufacturer', 'Manufacturer' )
   print_string( devpath, 'product',      'Product'      )
   print_string( devpath, 'serial',       'SerialNumber' )

   numifs      = int( cat( 'bNumInterfaces'     , devpath ) )
   cfgnum      = int( cat( 'bConfigurationValue', devpath ) )
   attr        = cat( 'bmAttributes', devpath )
   maxpower    = cat( 'bMaxPower'   , devpath )
   print( "C:  #Ifs=%2i Cfg#=%2i Atr=%s MxPwr=%s" % ( numifs, cfgnum, attr, maxpower ) )

   # --- There's not really any useful info in endpoint 00
   #     print_endpoint $devpath/ep_00

   for interface in glob.glob( devpath + '/' + str( busnum ) + '-*:?.*' ) :
      print_interface( interface )

   devcount = 0
   for subdev in glob.glob( devpath + '/' + str( busnum ) + '-*' ) :
      sName = os.path.basename( subdev )

      if ':' in sName : continue

      devcount += 1

      if os.path.isdir( subdev ) :
         print_device( subdev, devnum, level + 1, devcount )

# -----------------------------------------------------------------------------------
# --- Get / Init USB-Drives ...
# -----------------------------------------------------------------------------------
def init( opt=False ) :

   # --------------------------------------------------------------------------------
   if not os.path.exists( '/sys/bus' ) :
      print ( 'Error: directory /sys/bus does not exist; is sysfs mounted?', file=sys.stderr )
      return False

   # --------------------------------------------------------------------------------
   iFirst = False
   for sHub in glob.glob( sUsbRootPath + 'usb*' ) :
      print_device( sHub, 0, 0, 0, iLF=iFirst )
      iFirst = True

   # --------------------------------------------------------------------------------
   """
   sys.exit()
   # --------------------------------------------------------------------------------

   shortUSB = GetUsbID()

   for sID in sorted( shortUSB ) :
      print ( 'Host ID :', sID )
      for sName in sorted( shortUSB[ sID ] ) :
         print ( '{0:20} = {1}'.format( sName, shortUSB[ sID ][ sName ] ) )
   """

# -----------------------------------------------------------------------------------
# --- Entry point :
# -----------------------------------------------------------------------------------
if __name__ == '__main__' :
   init( sys.argv )

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
