# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright C 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# at your option any later version.                                                #
# -----------------------------------------------------------------------------------#

# -----------------------------------------------------------------------------------
# --- S.M.A.R.T. Attributes
# ---    Denotes a Critical attribute.
# ---    Specific values may predict drive failure.
# -----------------------------------------------------------------------------------
# --- DE Self-Monitoring, Analysis and Reporting Technology
# --> https://de.wikipedia.org/wiki/Self-Monitoring,_Analysis_and_Reporting_Technology
# --- EN S.M.A.R.T.
# --> https://en.wikipedia.org/wiki/S.M.A.R.T.
# --- EN Seagate's Seek Error Rate, Raw Read Error Rate, and Hardware ECC Recovered SMART attributes
# --> http://www.users.on.net/~fzabkar/HDD/Seagate_SER_RRER_HEC.html
# -----------------------------------------------------------------------------------
iSmartSign      = {  'Higher' : 'BlueArrowUp.png',
                     'Lower'  : 'BlueArrowDown.png',
                     'Denote' : 'BlueSquare.png', }

iWicki          = {
                       '1' : 'Lower',     # Attribut : Lower Lower value is better     Je niedriger der Wert, desto besser
                       '2' : 'Higher',    # Attribut : Higher Higher value is better   Je höher der Wert, desto besser
                       '3' : 'Lower',     # Attribut : Denotes a Critical attribute.   Ausfallsrelevanter Parameter.
                       '5' : 'Denote',
                       '7' : 'Lower',
                       '8' : 'Higher',
                       '9' : 'Lower',
                      '10' : 'Denote',
                      '11' : 'Lower',
                      '13' : 'Lower',
                      '22' : 'Higher',
                     '181' : 'Lower',
                     '183' : 'Lower',
                     '184' : 'Denote',
                     '187' : 'Denote',
                     '189' : 'Lower',
                     '190' : 'Lower',
                     '192' : 'Lower',
                     '193' : 'Lower',
                     '194' : 'Lower',
                     '195' : 'Lower',
                     '196' : 'Denote',
                     '197' : 'Denote',
                     '198' : 'Denote',
                     '199' : 'Lower',
                     '200' : 'Lower',
                     '201' : 'Denote',
                     '202' : 'Lower',
                     '203' : 'Lower',
                     '204' : 'Lower',
                     '205' : 'Lower',
                     '207' : 'Lower',
                     '220' : 'Lower',
                     '221' : 'Lower',
                     '224' : 'Lower',
                     '225' : 'Lower',
                     '227' : 'Lower',
                     '228' : 'Lower',
                     '250' : 'Lower',
                     '254' : 'Lower',
                  }

iSmartImportant = {
                       '1' : 'Denote',     # Raw_Read_Error_Rate <<-- Bei Seagate ändert sich der Wert laufend-
                       '2' : 'Higher',
                       '3' : 'Lower',
                       '5' : 'Denote',    # Reallocated_Sector_Ct
                       '7' : 'Lower',
                       '8' : 'Higher',
                       '9' : 'Lower',
                      '10' : 'Denote',    # Spin_Retry_Count
                      '11' : 'Lower',
                      '13' : 'Lower',
                      '22' : 'Higher',
                     '181' : 'Lower',
                     '183' : 'Lower',
                     '184' : 'Denote',    # End-to-End_Error_Count
                     '187' : 'Denote',    # Uncorrectable_Error_Cnt
                     '189' : 'Lower',
                     '190' : 'Lower',
                     '192' : 'Lower',
                     '193' : 'Lower',
                     '194' : 'Lower',
                     '195' : 'Lower',
                     '196' : 'Denote',    # Reallocated_Event_Count
                     '197' : 'Denote',    # Current_Pending_Sector
                     '198' : 'Denote',    # Offline_Uncorrectable
                     '199' : 'Denote',    # UDMA_CRC_Error_Count     <<-- Neu
                     '200' : 'Denote',    # Multi_Zone_Error_Rate    <<-- Neu
                     '201' : 'Denote',    # Soft Read Error Rate / Off Track Errors
                     '202' : 'Lower',
                     '203' : 'Lower',
                     '204' : 'Lower',
                     '205' : 'Lower',
                     '207' : 'Lower',
                     '220' : 'Lower',
                     '221' : 'Lower',
                     '224' : 'Lower',
                     '225' : 'Lower',
                     '227' : 'Lower',
                     '228' : 'Lower',
                     '250' : 'Lower',
                     '254' : 'Lower',
                  }

# -----------------------------------------------------------------------------------
# --- NVM_Express_Revision_1.3
# --- Translation table NVMe short names -> long names :
# -----------------------------------------------------------------------------------

NvmeIdCtrl =      {
                     # --- nvme id-ctrl /dev/nvme0
                     'vid'          : [ 'VID',     'PCI Vendor ID' ],
                     'ssvid'        : [ 'SSVID',   'PCI Subsystem Vendor' ],
                     'sn'           : [ 'SN',      'Serial Number' ],
                     'mn'           : [ 'MN',      'Model Number' ],
                     'fr'           : [ 'FR',      'Firmware Version' ],
                     'rab'          : [ 'RAB',     'Recommended Arbitration Burst' ],
                     'ieee'         : [ 'IEEE',    'IEEE OUI Identifier' ],
                     'cmic'         : [ 'CMIC',    'Controller Multi-Path I/O and Namespace Sharing Capabilities' ],
                     'mdts'         : [ 'MDTS',    'Maximum Data Transfer Size' ],
                     'cntlid'       : [ 'CNTLID',  'Controller ID' ],
                     'ver'          : [ 'VER',     'Version' ],
                     'rtd3r'        : [ 'RTD3R',   'RTD3 Resume Latency' ],
                     'rtd3e'        : [ 'RTD3E',   'RTD3 Entry Latency' ],
                     'oaes'         : [ 'OAES',    'Optional Asynchronous Events Supported' ],
                     'oacs'         : [ 'OACS',    'Optional Admin Command Support' ],
                     'acl'          : [ 'ACL',     'Abort Command Limit' ],
                     'aerl'         : [ 'AERL',    'Asynchronous Event Request Limit' ],
                     'frmw'         : [ 'FRMW',    'Firmware Updates' ],
                     'lpa'          : [ 'LPA',     'Log Page Attributes' ],
                     'elpe'         : [ 'ELPE',    'Error Log Page Entries' ],
                     'npss'         : [ 'NPSS',    'Number of Power States Support' ],
                     'avscc'        : [ 'AVSCC',   'Admin Vendor Specific Command Configuration' ],
                     'apsta'        : [ 'APSTA',   'Autonomous Power State Transition Attributes' ],
                     'wctemp'       : [ 'WCTEMP',  'Warning Composite Temperature Threshold' ],
                     'cctemp'       : [ 'CCTEMP',  'Critical Composite Temperature Threshold' ],
                     'mtfa'         : [ 'MTFA',    'Maximum Time for Firmware Activation' ],
                     'hmpre'        : [ 'HMPRE',   'Host Memory Buffer Preferred Size' ],
                     'hmmin'        : [ 'HMMIN',   'Host Memory Buffer Minimum Size' ],
                     'tnvmcap'      : [ 'TNVMCAP', 'Total NVM Capacity' ],
                     'unvmcap'      : [ 'UNVMCAP', 'Unallocated NVM Capacity' ],
                     'rpmbs'        : [ 'RPMBS',   'Replay Protected Memory Block Support' ],
                     'sqes'         : [ 'SQES',    'Submission Queue Entry Size' ],
                     'cqes'         : [ 'CQES',    'Completion Queue Entry Size' ],
                     'nn'           : [ 'NN',      'Number of Namespaces' ],
                     'oncs'         : [ 'ONCS',    'Optional NVM Command Support' ],
                     'fuses'        : [ 'FUSES',   'Fused Operation Support' ],
                     'fna'          : [ 'FNA',     'Format NVM Attributes' ],
                     'vwc'          : [ 'VWC',     'Volatile Write Cache' ],
                     'awun'         : [ 'AWUN',    'Atomic Write Unit Normal' ],
                     'awupf'        : [ 'AWUPF',   'Atomic Write Unit Power Fail' ],
                     'nvscc'        : [ 'NVSCC',   'NVM Vendor Specific Command Configuration' ],
                     'acwu'         : [ 'ACWU',    'Atomic Compare & Write Unit' ],
                     'sgls'         : [ 'SGLS',    'SGL Support' ],
                     # --- nvme id-ns /dev/nvme0n1
                     'nsze'         : [ 'NSZE',    'Namespace Size' ],
                     'ncap'         : [ 'NCAP',    'Namespace Capacity' ],
                     'nuse'         : [ 'NUSE',    'Namespace Utilization' ],
                     'nsfeat'       : [ 'NSFEAT',  'Namespace Features' ],
                     'nlbaf'        : [ 'NLBAF',   'Number of LBA Formats' ],
                     'flbas'        : [ 'FLBAS',   'Formatted LBA Size' ],
                     'mc'           : [ 'MC',      'Metadata Capabilities' ],
                     'dpc'          : [ 'DPC',     'End-to-end Data Protection Capabilities' ],
                     'dps'          : [ 'DPS',     'End-to-end Data Protection Type Settings' ],
                     'nmic'         : [ 'NMIC',    'Namespace Multi-path I/O and Namespace Sharing Capabilities' ],
                     'rescap'       : [ 'RESCAP',  'Reservation Capabilities' ],
                     'fpi'          : [ 'FPI',     'Format Progress Indicator' ],
                     'nawun'        : [ 'NAWUN',   'Namespace Atomic Write Unit Normal' ],
                     'nawupf'       : [ 'NAWUPF',  'Namespace Atomic Write Unit Power Fail' ],
                     'nacwu'        : [ 'NACWU',   'Namespace Atomic Compare & Write Unit' ],
                     'nabsn'        : [ 'NABSN',   'Namespace Atomic Boundary Size Normal' ],
                     'nabo'         : [ 'NABO',    'Namespace Atomic Boundary Offset' ],
                     'nabspf'       : [ 'NABSPF',  'Namespace Atomic Boundary Size Power Fail' ],
                     'nvmcap'       : [ 'NVMCAP',  'NVM Capacity Bytes' ],
                     'nguid'        : [ 'NGUID',   'Namespace Globally Unique Identifier' ],
                     'eui64'        : [ 'EUI64',   'IEEE Extended Unique Identifier' ],
                     'lbaf 0'       : [ 'LBAF0',   'LBA Format 0 Support' ],
                     'lbads'        : [ 'LBADS',   'LBA Data Size 2^9 = 512' ],
                     'ms'           : [ 'MS',      'Metadata Size Bytes' ],
                     'rp'           : [ 'RP',      'Relative Performance : Bits' ],
                     # --- nvme error-log /dev/nvme0
                     'Entry'        : [ 'Num',      'Current Number' ],
                     'error_count'  : [ 'ErrCount', 'Error Count' ],
                     'sqid'         : [ 'SQId',     'Submission Queue ID' ],
                     'cmdid'        : [ 'CmdId',    'Command ID' ],
                     'status_field' : [ 'Status',   'Status Field' ],
                     'parm_err_loc' : [ 'PELoc',    'Parameter Error Location' ],
                     'lba'          : [ 'LBA',      'LBA' ],
                     'nsid'         : [ 'NSID',     'Namespace' ],
                     'vs'           : [ 'VS',       'Vendor Specific Information Available' ],
                     # --- Power Management
                     'ps'           : [ 'PS',       'Power State' ],
                     'mp'           : [ 'MP',       'Maximum Power' ],
                     'enlat'        : [ 'ENTLAT',   'Entry Latency' ],
                     'exlat'        : [ 'EXLAT',    'Exit Latency' ],
                     'rrt'          : [ 'RRT',      'Relative Read Throughput' ],
                     'rrl'          : [ 'RRL',      'Relative Read Latency' ],
                     'rwt'          : [ 'rwt',      'Relative Write Throughput' ],
                     'rwl'          : [ 'RWT',      'Relative Write Latency' ],
                     'idle_power'   : [ 'Idle',     'Idle Power State' ],
                     'active_power' : [ 'Active',   'Active Power State' ],
                  }

